/*
 * Copyright © 2019 Apple Inc. and the ServiceTalk project authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.servicetalk.http.netty;

import io.servicetalk.http.api.PartitionedHttpClientBuilder;
import io.servicetalk.http.api.PartitionedHttpClientSecurityConfigurator;
import io.servicetalk.http.api.SingleAddressHttpClientSecurityConfigurator;

import java.io.InputStream;
import java.util.function.Supplier;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.TrustManagerFactory;

@Deprecated
final class DefaultPartitionedHttpClientSecurityConfigurator<U, R>
        implements PartitionedHttpClientSecurityConfigurator<U, R> {
    private final SingleAddressHttpClientSecurityConfigurator<U, R> delegate;
    private final PartitionedHttpClientBuilder<U, R> originalBuilder;

    DefaultPartitionedHttpClientSecurityConfigurator(final SingleAddressHttpClientSecurityConfigurator<U, R> delegate,
                                                     final PartitionedHttpClientBuilder<U, R> originalBuilder) {
        this.delegate = delegate;
        this.originalBuilder = originalBuilder;
    }

    @Override
    public PartitionedHttpClientBuilder<U, R> commit() {
        delegate.commit();
        return originalBuilder;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> trustManager(
            final Supplier<InputStream> trustCertChainSupplier) {
        delegate.trustManager(trustCertChainSupplier);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> trustManager(final TrustManagerFactory trustManagerFactory) {
        delegate.trustManager(trustManagerFactory);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> protocols(final String... protocols) {
        delegate.protocols(protocols);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> ciphers(final Iterable<String> ciphers) {
        delegate.ciphers(ciphers);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> sessionCacheSize(final long sessionCacheSize) {
        delegate.sessionCacheSize(sessionCacheSize);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> sessionTimeout(final long sessionTimeout) {
        delegate.sessionTimeout(sessionTimeout);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> provider(final SslProvider provider) {
        delegate.provider(provider);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> hostnameVerificationAlgorithm(
            final String hostNameVerificationAlgorithm) {
        delegate.hostnameVerificationAlgorithm(hostNameVerificationAlgorithm);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> hostnameVerification(
            final String hostNameVerificationAlgorithm, final String hostNameVerificationHost) {
        delegate.hostnameVerification(hostNameVerificationAlgorithm, hostNameVerificationHost);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> hostnameVerification(
            final String hostNameVerificationAlgorithm, final String hostNameVerificationHost,
            final int hostNameVerificationPort) {
        delegate.hostnameVerification(hostNameVerificationAlgorithm, hostNameVerificationHost,
                hostNameVerificationPort);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> hostnameVerification(final String hostNameVerificationHost) {
        delegate.hostnameVerification(hostNameVerificationHost);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> hostnameVerification(final String hostNameVerificationHost,
                                                                                final int hostNameVerificationPort) {
        delegate.hostnameVerification(hostNameVerificationHost, hostNameVerificationPort);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> sniHostname(final String sniHostname) {
        delegate.sniHostname(sniHostname);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> disableHostnameVerification() {
        delegate.disableHostnameVerification();
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> keyManager(final KeyManagerFactory keyManagerFactory) {
        delegate.keyManager(keyManagerFactory);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> keyManager(final Supplier<InputStream> keyCertChainSupplier,
                                                                      final Supplier<InputStream> keySupplier) {
        delegate.keyManager(keyCertChainSupplier, keySupplier);
        return this;
    }

    @Override
    public PartitionedHttpClientSecurityConfigurator<U, R> keyManager(final Supplier<InputStream> keyCertChainSupplier,
                                                                      final Supplier<InputStream> keySupplier,
                                                                      final String keyPassword) {
        delegate.keyManager(keyCertChainSupplier, keySupplier, keyPassword);
        return this;
    }
}
